com.google.gwt.core.linker

## Class XSLinker

- java.lang.Object
- - com.google.gwt.core.ext.Linker
  - - com.google.gwt.core.ext.linker.AbstractLinker
    - - com.google.gwt.core.ext.linker.impl.SelectionScriptLinker
      - - com.google.gwt.core.linker.XSLinker

- Deprecated.
  use `CrossSiteIframeLinker` instead.

      @LinkerOrder(value=PRIMARY)
       @Shardable
       @Deprecated
      public class XSLinker
      extends com.google.gwt.core.ext.linker.impl.SelectionScriptLinker

  Generates a cross-site compatible bootstrap sequence.

- - ### Field Summary

    - ### Fields inherited from class com.google.gwt.core.ext.linker.impl.SelectionScriptLinker

      `COMPUTE_SCRIPT_BASE_JS, FRAGMENT_EXTENSION, FRAGMENT_SUBDIR, permutationsUtil, PROCESS_METAS_JS, USE_SOURCE_MAPS_PROPERTY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XSLinker()` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.String` | `getCompilationExtension(TreeLogger logger, LinkerContext context)` Deprecated.
    `java.lang.String` | `getDescription()` Deprecated. Returns a human-readable String describing the Linker.
    `protected java.lang.String` | `getModulePrefix(TreeLogger logger, LinkerContext context, java.lang.String strongName)` Deprecated. Compute the beginning of a JavaScript file that will hold the main module implementation.
    `protected java.lang.String` | `getModulePrefix(TreeLogger logger, LinkerContext context, java.lang.String strongName, int numFragments)` Deprecated. Compute the beginning of a JavaScript file that will hold the main module implementation.
    `protected java.lang.String` | `getModuleSuffix2(TreeLogger logger, LinkerContext context, java.lang.String strongName)` Deprecated. Returns the suffix for the initial JavaScript fragment.
    `protected java.lang.String` | `getSelectionScriptTemplate(TreeLogger logger, LinkerContext context)` Deprecated.
    `ArtifactSet` | `link(TreeLogger logger, LinkerContext context, ArtifactSet artifacts, boolean onePermutation)` Deprecated. This method is invoked for linkers annotated with `Shardable`.
    `protected java.lang.String` | `wrapDeferredFragment(TreeLogger logger, LinkerContext context, int fragment, java.lang.String js, ArtifactSet artifacts)` Deprecated.

    - ### Methods inherited from class com.google.gwt.core.ext.linker.impl.SelectionScriptLinker

      `charsPerChunk, doEmitCompilation, emitSelectionInformation, emitSelectionScript, fillSelectionScriptTemplate, generateDeferredFragment, generatePrimaryFragment, generatePrimaryFragmentString, generateSelectionScript, generateSelectionScript, getDeferredFragmentPrefix, getDeferredFragmentSuffix2, getFragmentSubdir, getHostedFilename, getScriptChunkSeparator, link, maybeAddHostedModeFile, maybeOutputPropertyMap, readFileToStringBuffer, replaceAll, splitPrimaryJavaScript, supportsDevModeInJunit, wrapPrimaryFragment`

    - ### Methods inherited from class com.google.gwt.core.ext.linker.AbstractLinker

      `emitBytes, emitBytes, emitInputStream, emitInputStream, emitString, emitString, emitWithStrongName, emitWithStrongName`

    - ### Methods inherited from class com.google.gwt.core.ext.Linker

      `isShardable, relink`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XSLinker

          public XSLinker()

      Deprecated.

  - ### Method Detail

    - #### getDescription

          public java.lang.String getDescription()

      Deprecated.
      Description copied from class: `Linker`
      Returns a human-readable String describing the Linker.
      Specified by:
        `getDescription` in class `Linker`

    - #### link

          public ArtifactSet link(TreeLogger logger,
                                  LinkerContext context,
                                  ArtifactSet artifacts,
                                  boolean onePermutation)
                           throws UnableToCompleteException

      Deprecated.
      Description copied from class: `Linker`

      This method is invoked for linkers annotated with `Shardable`. It is called at two points during compilation: after the compile of each permutation, and after all compilation has finished. The `onePermutation` is `true` for a per-permutation call and `false` for a global final-link call.

      For one-permutation calls, this method is passed all artifacts generated for just the one permutation. For the global call at the end of compilation, this method sees artifacts for the whole compilation, but with two modifications intended to support builds on computer clusters:

      1. All EmittedArtifacts have been converted to BinaryEmittedArtifacts
      2. All artifacts not marked as `Transferable` have been discarded.
      Overrides:
        `link` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`
      Parameters:
        `logger` - the TreeLogger to record to
        `context` - provides access to the Linker's environment
        `artifacts` - an unmodifiable view of the artifacts to link
        `onePermutation` - true for a one-permutation call
      Returns:
        the artifacts that should be propagated through the linker chain
      Throws:
        `UnableToCompleteException` - if compilation violates assumptions made by the Linker or for errors encountered by the Linker

    - #### getCompilationExtension

          protected java.lang.String getCompilationExtension(TreeLogger logger,
                                                             LinkerContext context)

      Deprecated.
      Specified by:
        `getCompilationExtension` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`

    - #### getModulePrefix

          protected java.lang.String getModulePrefix(TreeLogger logger,
                                                     LinkerContext context,
                                                     java.lang.String strongName)

      Deprecated.
      Description copied from class: `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`
      Compute the beginning of a JavaScript file that will hold the main module implementation.
      Specified by:
        `getModulePrefix` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`

    - #### getModulePrefix

          protected java.lang.String getModulePrefix(TreeLogger logger,
                                                     LinkerContext context,
                                                     java.lang.String strongName,
                                                     int numFragments)

      Deprecated.
      Description copied from class: `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`
      Compute the beginning of a JavaScript file that will hold the main module implementation. By default, calls `SelectionScriptLinker.getModulePrefix(TreeLogger, LinkerContext, String)`.
      Overrides:
        `getModulePrefix` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`
        `strongName` - strong name of the module being emitted
        `numFragments` - the number of fragments for this module, including the main fragment (fragment 0)

    - #### getModuleSuffix2

          protected java.lang.String getModuleSuffix2(TreeLogger logger,
                                                      LinkerContext context,
                                                      java.lang.String strongName)

      Deprecated.
      Description copied from class: `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`
      Returns the suffix for the initial JavaScript fragment.
      Overrides:
        `getModuleSuffix2` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`

    - #### getSelectionScriptTemplate

          protected java.lang.String getSelectionScriptTemplate(TreeLogger logger,
                                                                LinkerContext context)

      Deprecated.
      Specified by:
        `getSelectionScriptTemplate` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`

    - #### wrapDeferredFragment

          protected java.lang.String wrapDeferredFragment(TreeLogger logger,
                                                          LinkerContext context,
                                                          int fragment,
                                                          java.lang.String js,
                                                          ArtifactSet artifacts)

      Deprecated.
      Overrides:
        `wrapDeferredFragment` in class `com.google.gwt.core.ext.linker.impl.SelectionScriptLinker`